<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/21/2009 *
 * ===============                              Last change: 10/21/2009 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : other_functions.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Special functions for other extension            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Spezielle Funktion fuer Debug-Erweiterung        *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Displays all SQL queries with num rows, affected rows and timings
function displayDebugSqls () {
	// Walk through all SQLs
	$OUT = ''; $SW = 2; $i = 1;
	foreach ($GLOBALS['debug_sqls'] as $content) {
		// Translate/add some data
		$content['sw']       = $SW;
		$content['i']        = $i;
		$content['num_rows'] = translateComma($content['num_rows']);
		$content['affected'] = translateComma($content['affected']);
		$content['sql_str']  = secureString($content['sql_str']);
		$content['timing']   = translateComma($content['timing'] * 1000);

		// Load row template
		$OUT .= loadTemplate('admin_other_sqls_row', true, $content);

		// Switch color
		$SW = 3 - $SW; $i++;
	} // END - foreach

	// Load main template
	loadTemplate('admin_other_sqls', false, $OUT);
}

// Filter for debugging SQLs
function FILTER_DISPLAY_DEBUG_SQL () {
	// Shall we display SQL queries?
	if ((isAdmin()) && (isExtensionInstalledAndNewer('other', '0.2.2')) && (getConfig('display_debug_sqls') == 'Y') && (!isGetRequestElementSet('frame')) && ($GLOBALS['header_sent'] == 2)) {
		// Then display it here
		displayDebugSqls();
	} // END - if
}

// [EOF]
?>
