<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/29/2003 *
 * ===============                              Last change: 01/06/2006 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : order.php                                        *
 * -------------------------------------------------------------------- *
 * Short description : Submits your order to the administrators         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sendet die Buchung an die Administratoren        *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
$URL = '';
if (!defined('__SECURITY')) {
	die();
} elseif ((!isExtensionActive('order')) && (!isAdmin())) {
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('order'));
	return;
} elseif (!isMember()) {
	// Sorry, no guest access!
	$URL = 'modules.php?module=index';
} elseif (!isGetRequestElementSet('order')) {
	// You cannot call this module directly!
	$URL = 'modules.php?module=login&amp;what=order';
}

// When URL is empty nothing bad happend here
if (empty($URL)) {
	// Is the auto-send mechanism active or inactive?
	if (getConfig('autosend_active') == 'Y') {
		// Auto-send is active
		$content['admin_autosend']  = getMessage('ADMIN_AUTOSEND_ACTIVE');
		$content['member_autosend'] = getMessage('MEMBER_AUTOSEND_ACTIVE');
		$type = 'NEW';
	} else {
		// Auto-send is inactive
		$content['admin_autosend']  = getMessage('ADMIN_AUTOSEND_INACTIVE');
		$content['member_autosend'] = getMessage('MEMBER_AUTOSEND_INACTIVE');
		$type = 'ADMIN';
	}

	// Update sending pool
	SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_pool` SET `data_type`='%s' WHERE `id`=%s AND `sender`=%s AND `data_type`='TEMP' LIMIT 1",
		array($type, bigintval(getRequestElement('order')), getUserId()), __FILE__, __LINE__);

	// Finally is the entry valid?
	if (SQL_AFFECTEDROWS() == 1) {
		// @TODO Unused: 2,4
		// Load mail again...              0         1          2             3            4         5       6            7
		$result = SQL_QUERY_ESC("SELECT `subject`, `text`, `receivers`, `payment_id`, `timestamp`, `url`, `cat_id`, `target_send` FROM `{?_MYSQL_PREFIX?}_pool` WHERE `id`=%s AND `sender`=%s LIMIT 1",
			array(bigintval(getRequestElement('order')), getUserId()), __FILE__, __LINE__);
		$content = merge_array($content, SQL_FETCHARRAY($result));
		SQL_FREERESULT($result);
		if (empty($content['subject'])) $content['subject'] = getMessage('DEFAULT_SUBJECT_LINE');

		// Calculate used points
		$usedPoints = $content['target_send'] * getPaymentPoints($content['payment_id']);

		// Update used points
		$add = '';
		if (getConfig('order_max_full') == 'ORDER') $add = ', mail_orders=mail_orders+1';
		subtractPoints('order', getUserId(), $usedPoints);

		// Compile content
		$content['payment']  = getPaymentTitlePrice($content['payment_id']);
		$content['category'] = getCategory($content['cat_id']);

		// Send an email to the user
		$message_mem = loadEmailTemplate('order-member', $content, getUserId());
		sendEmail(getUserId(), getMessage('MEMBER_NEW_QUEUE'), $message_mem);

		// Notify admins about this
		sendAdminNotification(getMessage('ADMIN_NEW_QUEUE'), 'order-admin', $content, getUserId());

		// Create new task
		createNewTask(
			'{--ADMIN_NEW_QUEUE--}',
			'<pre>'.loadEmailTemplate('order-admin', $content, getUserId()).'</pre>',
			'MEMBER_ORDER',
			getUserId(),
			0,
			false
		);

		// Output back bottom
		loadTemplate('member_order-back');
	} else {
		// Matching line not found or already 'placed' in send queue
		redirectToUrl('modules.php?module=login');
	}
} else {
	// Redirect...
	redirectToUrl($URL);
}

// [EOF]
?>
